﻿using System;
using System.Collections.Generic;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace RadRibbonBarIteration
{
    public partial class Form1 : RadForm
    {
        private Dictionary<string, string> items;
        public Form1()
        {
            this.InitializeComponent();

            this.items = new Dictionary<string, string>();
            this.items.Add(this.radButtonElement1.Name, "New Text");
            this.items.Add(this.radButtonElement2.Name, "New QAT");
            this.items.Add(this.radRibbonBarGroup1.Name, "New Group 1");
            this.items.Add(this.ribbonTab1.Name, "New Tab 1");
        }

        private void radButtonChangeTextAndTooltip_Click(object sender, EventArgs e)
        {
            this.FindInRibbonBarItems();
        }

        public RadItem FindInRibbonBarItems()
        {
            this.FindInQuickAccessBarItems();

            for (int i = 0; i < this.radRibbonBar1.CommandTabs.Count; i++)
            {
                RibbonTab ribbonTab = this.radRibbonBar1.CommandTabs[i] as RibbonTab;
                ribbonTab.Text = this.items[ribbonTab.Name];

                for (int j = 0; j < ribbonTab.Items.Count; j++)
                {
                    RadRibbonBarGroup ribbonBarGroup = ribbonTab.Items[j] as RadRibbonBarGroup;
                    ribbonBarGroup.Text = this.items[ribbonBarGroup.Name];

                    for (int k = 0; k < ribbonBarGroup.Items.Count; k++)
                    {
                        RadItem currentItem = this.GetRibbonBarGroupChildren(ribbonBarGroup.Items[k]);
                        if (currentItem != null)
                        {
                            currentItem.Text = this.items[currentItem.Name];
                        }
                    }
                }
            }

            return null;
        }

        private RadItem FindInQuickAccessBarItems()
        {
            for (int i = 0; i < this.radRibbonBar1.QuickAccessToolBarItems.Count; ++i)
            {
                RadItem item = this.radRibbonBar1.QuickAccessToolBarItems[i];
                item.Text = this.items[item.Name];
            }

            for (int i = 0; i < this.radRibbonBar1.RibbonBarElement.QuickAccessToolBar.OverflowButtonElement.Items.Count; ++i)            
            {
                RadItem item = this.radRibbonBar1.RibbonBarElement.QuickAccessToolBar.OverflowButtonElement.Items[i];
                item.Text = this.items[item.Name];
            }

            return null;
        }

        private RadItem GetRibbonBarGroupChildren(RadItem parentItem)
        {
            RadRibbonBarButtonGroup buttonGroup = parentItem as RadRibbonBarButtonGroup;
            if (buttonGroup == null)
            {
                parentItem.Text = this.items[parentItem.Name];

                return null;
            }

            for (int i = 0; i < buttonGroup.Items.Count; i++)
            { 
                RadItem currentItem = this.GetRibbonBarGroupChildren(buttonGroup.Items[i]);
                if (currentItem != null)
                {
                    currentItem.Text = this.items[currentItem.Name];
                }
            }

            return null;
        }
    }
}